#!/usr/bin/perl

###########################################################################
#            Copyright (C) 2000 John David Ratliff                        #
#                                                                         #
# Permission is hereby granted, free of charge, to any person obtaining   #
# a copy of this software and associated documentation files (the         #
# "Software"), to deal in the Software without restriction, including     #
# without limitation the rights to use, copy, modify, merge, publish,     #
# distribute, sublicense, and/or sell copies of the Software, and to      #
# permit persons to whom the Software is furnished to do so, subject to   #
# the following conditions:                                               #
#                                                                         #
# The above copyright notice and this permission notice shall be included #
# in all copies or substantial portions of the Software.                  #
#                                                                         #
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,         #
# EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF      #
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  #
# IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY    #
# CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,    #
# TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE       #
# SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.                  #
###########################################################################

use CGI qw(:param);
use DBI;

require "lib/dbi-connect.pl";
require "lib/error.pl";

#########################################################################################################
#
# Declare the local variables, print the content type, set the script variable, establish the database
# connection and print the header
#

local ($script,$dbh,$error,$username,$password,$pass,$pass2);
local ($name,$email,$street,$city,$zip,$phone,$gender,$sql,$sth);

print "Content-type: text/html\n\n";

$script = "account.cgi";
$dbh = dbiConnect($dbname);

print <<HTML;
<html>

<head>
	<title>Update Account Information</title>

	<style fprolloverstyle>
		A:hover {color: darkgreen; font-weight: bold}
	</style>
</head>

<body background="/images/background.gif" link="#800000" vlink="#C00000" alink="#000080">
HTML

#########################################################################################################
#
# Confirm that the username and password were entered
#
#

$username = param("username");
$password = param("password");

if ($username eq "" or $password eq "") {
	print qq|<h3 align="center">You cannot leave the username or password fields blank!</h3>\n|;
	print qq|<h4 align="center">Press the back button to correct this.</h4>\n|;

#########################################################################################################
#
# Either update the account with the new information, or print the update form
#
#

} else {
	$sql = "select password(?)";
	$sth = $dbh->prepare($sql);
	$sth->execute($password);
	$error = $dbh->errstr;
	$pass = $sth->fetchrow_array();
	$sth->finish;

	if ($error ne "") {
		handle($error,$script);
		die "Database Error: ${error}";
	}

	$sql = "select password from patrons where username = ?";
	$sth = $dbh->prepare($sql);
	$sth->execute($username);
	$error = $dbh->errstr;
	$pass2 = $sth->fetchrow_array();
	$sth->finish;

	if ($error ne "") {
		handle($error,$script);
		die "Database Error: ${error}";
	}

	if ($pass eq $pass2) {
		if (param("update")) {
			$name = param("name");
			$email = param("email");
			$street = param("street");
			$city = param("city");
			$zip = param("zip");
			$phone = param("phone");
			$gender = param("gender");

			$sql = "update patrons set name = ?, email = ?, street = ?, city = ?, zip = ?, phone = ?, gender = ? where username = ?";
			$sth = $dbh->prepare($sql);
			$sth->execute($name,$email,$street,$city,$zip,$phone,$gender,$username);
			$error = $dbh->errstr;
			$sth->finish;

			if ($error ne "") {
				handle($error,$script);
				die "Database Error: ${error}";
			}

			print qq|<h3 align="center">Your Account Has Been Successfully Updated.</h3>\n|;
		} else {
			$sql = "select name,email,street,city,zip,phone,gender from patrons where username = ?";
			$sth = $dbh->prepare($sql);
			$sth->execute($username);
			$error = $dbh->errstr;
			($name,$email,$street,$city,$zip,$phone,$gender) = $sth->fetchrow_array();
			$sth->finish;

			if ($error ne "") {
				handle($error,$script);
				die "Database Error: ${error}";
			}

			print qq|<h1 align="center">Update Account Information</h1>\n|;

			print qq|<center><table width="75%" border="1" bgcolor="#000000"><form method="POST" action="account.cgi">\n|;
			print qq|<input type="hidden" name="update" value="1"><input type="hidden" name="username" value="${username}"><input type="hidden" name="password" value="${password}">\n|;
			print qq|<tr><td width="20%" bgcolor="#D3C1B6" align="center">Name: </td><td width="80%" bgcolor="#D3C1B6"><input type="text" name="name" value="${name}" size="30"></td></tr>\n|;
			print qq|<tr><td width="20%" bgcolor="#D3C1B6" align="center">E-Mail: </td><td width="80%" bgcolor="#D3C1B6"><input type="text" name="email" value="${email}" size="30"></td></tr>\n|;
			print qq|<tr><td width="20%" bgcolor="#D3C1B6" align="center">Street Address: </td><td width="80%" bgcolor="#D3C1B6"><input type="text" name="street" value="${street}" size="30"></td></tr>\n|;
			print qq|<tr><td width="20%" bgcolor="#D3C1B6" align="center">City: </td><td width="80%" bgcolor="#D3C1B6"><input type="text" name="city" value="${city}" size="30"></td></tr>\n|;
			print qq|<tr><td width="20%" bgcolor="#D3C1B6" align="center">Zipcode: </td><td width="80%" bgcolor="#D3C1B6"><input type="text" name="zip" value="${zip}" size="5"></td></tr>\n|;
			print qq|<tr><td width="20%" bgcolor="#D3C1B6" align="center">Telephone: </td><td width="80%" bgcolor="#D3C1B6"><input type="text" name="phone" value="${phone}" size="12"></td></tr>\n|;
			print qq|<tr><td width="20%" bgcolor="#D3C1B6" align="center">Gender: </td><td width="80%" bgcolor="#D3C1B6"><select name="gender" height="1">|;

			if ($gender eq "Male") {
				print qq|<option selected value="Male">Male</option><option value="Female">Female</option></select></td></tr>\n|;
			} else {
				print qq|<option value="Male">Male</option><option selected value="Female">Female</option></select></td></tr>\n|;
			}

			print qq|<tr><td width="100%" colspan="2" align="left" bgcolor="#D3C1B6"><input type="submit" value="Update Account"></td>\n</table></form></center><br>\n|;
		}
	} else {
		print qq|<h3 align="center">Invalid Username or Password!</h3><br>\n|;
	}
}

print qq|<center><a href="index.html"><strong>Return to the Main Page</strong></a><br><img border="0" src="/images/book.gif" width="116" height="68"></center>\n</body>\n</html>\n|;

$dbh->disconnect;
