#!/usr/bin/perl

###########################################################################
#            Copyright (C) 2000 John David Ratliff                        #
#                                                                         #
# Permission is hereby granted, free of charge, to any person obtaining   #
# a copy of this software and associated documentation files (the         #
# "Software"), to deal in the Software without restriction, including     #
# without limitation the rights to use, copy, modify, merge, publish,     #
# distribute, sublicense, and/or sell copies of the Software, and to      #
# permit persons to whom the Software is furnished to do so, subject to   #
# the following conditions:                                               #
#                                                                         #
# The above copyright notice and this permission notice shall be included #
# in all copies or substantial portions of the Software.                  #
#                                                                         #
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,         #
# EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF      #
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  #
# IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY    #
# CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,    #
# TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE       #
# SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.                  #
###########################################################################

use CGI qw(:param);
use DBI;

require "lib/dbi-connect.pl";
require "lib/error.pl";
require "lib/date.pl";
require "lib/checkout.pl";

#########################################################################################################
#
# Declare the local variables, print the content type, set the script variable, establish the database
# connection and print the header
#

local ($script,$dbh,$error,$username,$password,$sql,$sth,$sth2,$pass2,@ctime,$publisher,$length,$rating,$system);
local ($id,$name,$fines,$results,$books,$movies,$uid,$media,$title,$author,$description,$sg,$year,$rtime);

print "Content-type: text/html\n\n";

$script = "checkout.cgi";
$dbh = dbiConnect($dbname);

print <<HTML;
<html>

<head>
	<title>Examine Your Checkout List</title>

	<style fprolloverstyle>
		A:hover {color: darkgreen; font-weight: bold}
	</style>
</head>

<body background="/images/background.gif" link="#800000" vlink="#C00000" alink="#000080">
HTML

#########################################################################################################
#
# Check to make sure the user entered a username and password.
#
#

$username = param("username");
$password = param("password");

if ($username eq "" or $password eq "") {
	print qq|<h3 align="center">You cannot leave the username or password fields blank!</h3>\n|;
	print qq|<h4 align="center">Press the back button to correct this.</h4>\n|;

#########################################################################################################
#
# Print the list of checkouts and reservations.
#
#

} else {
	$sql = "select password(\"${password}\")";
	$sth = $dbh->prepare($sql);
	$sth->execute();
	$error = $dbh->errstr;
	$password = $sth->fetchrow_array();
	$sth->finish;

	if ($error ne "") {
		handle($error,$script);
		die "Database Error: ${error}";
	}

	$sql = "select password from patrons where username = ?";
	$sth = $dbh->prepare($sql);
	$sth->execute($username);
	$error = $dbh->errstr;
	$pass2 = $sth->fetchrow_array();
	$sth->finish;

	if ($error ne "") {
		handle($error,$script);
		die "Database Error: ${error}";
	}

	if ($password eq $pass2) {
		$sql = "select id,name,fines from patrons where username = ?";
		$sth = $dbh->prepare($sql);
		$sth->execute($username);
		$error = $dbh->errstr;
		($id,$name,$fines) = $sth->fetchrow_array();
		$sth->finish;

		if ($error ne "") {
			handle($error,$script);
			die "Database Error: ${error}";
		}

		(@ctime) = localtime(time);

		$ctime[5]+=1900;
		$ctime[4]++;

		$time = "$ctime[5]";

		if ($ctime[4] < 10) {
			$time .= "0$ctime[4]";
		} else {
			$time .= "$ctime[4]";
		}

		if ($ctime[3] < 10) {
			$time .= "0$ctime[3]";
		} else {
			$time .= "$ctime[3]";
		}

		print qq|<h1 align="center">Checkout List for ${name}</h1>\n|;

		if ($fines > 0.00) {
			print qq|<h2 align="center">You Owe \$${fines} in Late Fees</h2>\n|;
		}


#############################

		$sql = "select id from catalog where patron = $id";
		$results = $dbh->do($sql);
		$error = $dbh->errstr;

		if ($error ne "") {
			handle($error,$script);
			die "Database Error: ${error}";
		}

		$books = getBooks($id);
		$movies = getMovies($id);

		print qq|<br>\n<h3 align="center">You Have |;

		if ($results == 0) {
			print qq|0 Items Out.</h3>\n|;
		} elsif ($results > 1) {
			print qq|${results} Items Out.</h3>\n|;
		} else {
			print qq|1 Item Out.</h3>\n|;
		}

		print $books,$movies;

#############################

		$sql = "select id,media,title,author,sg,publisher,year,description,length,rating,system,rtime from catalog where reserve = ? and patron != ? order by media,author,title";
		$sth = $dbh->prepare($sql);
		$sth->execute($id,$id);
		$error = $dbh->errstr;

		$display = "";
		$results = $sth->rows;

		while (($uid,$media,$title,$author,$sg,$publisher,$year,$description,$length,$rating,$sytem,$rtime) = $sth->fetchrow_array()) {
			$display .= qq|<center><table width="75%" border="1" bgcolor="#000000"><form method="POST" action="reserve.cgi">\n|;
			$display .= qq|<input type="hidden" name="cancel" value="1"><input type="hidden" name="id" value="${uid}"><input type="hidden" name="media" value="${media}"><input type="hidden" name="username" value="${username}"><input type="hidden" name="password" value="${password}">\n|;
			$display .= qq|<tr><td width="100%" bgcolor="#D3C1B6" align="center" colspan="2"><strong>${title}</strong></td></tr>\n|;

			if ($media == 1) {
				$display .= qq|<tr><td width="20%" bgcolor="#D3C1B6" align="center">Author: </td><td width="80%" bgcolor="#D3C1B6">${author}</td></tr>\n|;
				$display .= qq|<tr><td width="20%" bgcolor="#D3C1B6" align="center">Subject: </td><td width="80%" bgcolor="#D3C1B6">${sg}</td></tr>\n|;
				$display .= qq|<tr><td width="20%" bgcolor="#D3C1B6" align="center">Publisher: </td><td width="80%" bgcolor="#D3C1B6">${publisher}</td></tr>\n|;
				$display .= qq|<tr><td width="20%" bgcolor="#D3C1B6" align="center">Year of Publication: </td><td width="80%" bgcolor="#D3C1B6">${year}</td></tr>\n|;
			} elsif ($media == 2) {
				$display .= qq|<tr><td width="20%" bgcolor="#D3C1B6" align="center">Genre: </td><td width="80%" bgcolor="#D3C1B6">${sg}</td></tr>\n|;
				$display .= qq|<tr><td width="20%" bgcolor="#D3C1B6" align="center">Rating: </td><td width="80%" bgcolor="#D3C1B6">${rating}</td></tr>\n|;
				$display .= qq|<tr><td width="20%" bgcolor="#D3C1B6" align="center">Length: </td><td width="80%" bgcolor="#D3C1B6">${length}</td></tr>\n|;

				if ($system == 1) {
					$display .= qq|<tr><td width="20%" bgcolor="#D3C1B6" align="center">System: </td><td width="80%" bgcolor="#D3C1B6">VHS Videocasette</td></tr>\n|;
				} elsif ($system == 2) {
					$display .= qq|<tr><td width="20%" bgcolor="#D3C1B6" align="center">System: </td><td width="80%" bgcolor="#D3C1B6">DVD Disc</td></tr>\n|;
				}
			}

			$display .= qq|<tr><td width="20%" bgcolor="#D3C1B6" align="center">Description: </td><td width="80%" bgcolor="#D3C1B6">${description}</td></tr>\n|;

			if ($rtime != 0) {
				$sql = "select date_format(adddate(from_days(to_days(?)),interval 7 day),'%W, %M %e, %Y')";
				$sth2 = $dbh->prepare_cached($sql);
				$sth2->execute($rtime);
				$rtime = $sth2->fetchrow_array();
				$error = $dbh->errstr;
				$sth2->finish;

				if ($error ne "") {
					handle($error,$script);
					die "Database Error: ${error}";
				}

				$display .= qq|<tr><td width="20%" bgcolor="#D3C1B6" align="center">Reservation Expires: </td><td width="80%" bgcolor="#D3C1B6">${rtime}</td></tr>\n|;
			}

			$display .= qq|<tr><td width="100%" bgcolor="#D3C1B6" align="left" colspan="2"><input type="submit" value="Cancel Reservation"></td></tr>\n|;
			$display .= qq|</table></center><br>\n|;
		}
		$sth->finish;

		if ($error ne "") {
			handle($error,$script);
			die "Database Error: ${error}";
		}

		print qq|<br>\n<h3 align="center">You Have |;

		if ($results > 1 or $results == 0) {
			print qq|${results} Items On Reserve.</h3>\n|;
		} else {
			print qq|1 Item Reserved.</h3>\n|;
		}

		print $display;
	} else {
		print qq|<h3 align="center">Invalid Username or Password!</h3>\n|;
	}
}

print qq|<center><a href="index.html"><strong>Return to the Main Page</strong></a><br><img border="0" src="/images/book.gif" width="116" height="68"></center>\n</body>\n</html>\n|;

$dbh->disconnect;
