#!/usr/bin/perl

###########################################################################
#            Copyright (C) 2000 John David Ratliff                        #
#                                                                         #
# Permission is hereby granted, free of charge, to any person obtaining   #
# a copy of this software and associated documentation files (the         #
# "Software"), to deal in the Software without restriction, including     #
# without limitation the rights to use, copy, modify, merge, publish,     #
# distribute, sublicense, and/or sell copies of the Software, and to      #
# permit persons to whom the Software is furnished to do so, subject to   #
# the following conditions:                                               #
#                                                                         #
# The above copyright notice and this permission notice shall be included #
# in all copies or substantial portions of the Software.                  #
#                                                                         #
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,         #
# EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF      #
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  #
# IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY    #
# CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,    #
# TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE       #
# SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.                  #
###########################################################################

use CGI qw(:param);
use DBI;

require "lib/dbi-connect.pl";
require "lib/error.pl";

#########################################################################################################
#
# Declare the local variables, print the content type, set the script variable, establish the database
# connection and print the header
#

local ($script,$dbh,$error,$id,$confirm,$password,$pass2,$sql,$sth,$code);

print "Content-type: text/html\n\n";

$script = "confirm.cgi";
$dbh = dbiConnect($dbname);

print <<HTML;
<html>

<head>
	<title>Confirm Your Account</title>

	<style fprolloverstyle>
		A:hover {color: darkgreen; font-weight: bold}
	</style>
</head>

<body background="/images/background.gif" link="#800000" vlink="#C00000" alink="#000080">
HTML

$id = param("id");
$confirm = param("confirm");

#########################################################################################################
#
# Set or change the password for this patron's account provided the two password's sent match.
#
#

if (param("password")) {
	$password = param("password");
	$pass2 = param("pass2");

	$sql = "select code from patrons where id = ?";
	$sth = $dbh->prepare($sql);
	$sth->execute($id);
	$error = $dbh->errstr;
	$code = $sth->fetchrow_array();
	$sth->finish;

	if ($error ne "") {
		handle($error,$script);
		die "Database Error: ${error}";
	}

	if (length($confirm) != 8 or $confirm ne $code) {
		print qq|${confirm}<br><br>\n|;
		print qq|<h3 align="center">Invalid confirmation code.</h3>\n|;
		print qq|<center><a href="index.html"><strong>Return to the Main Page</strong></a><br><img border="0" src="/images/book.gif" width="116" height="68"></center>\n</body>\n</html>\n|;
		die;
	}

	if (length($password) < 6 or length($password) > 20 or (($password =~ /'/) != 0)) {
		print qq|<h3 align="center">Invalid Password. Passwords must contain between 6 and 20 characters and cannot contain apostrophes.</h3>\n|;
		print qq|<center><a href="index.html"><strong>Return to the Main Page</strong></a><br><img border="0" src="/images/book.gif" width="116" height="68"></center>\n</body>\n</html>\n|;
		die;
	}

	if ($password eq $pass2) {
		$sql = "select password(\"${password}\")";
		$sth = $dbh->prepare($sql);
		$sth->execute();
		$error = $dbh->errstr;
		$password = $sth->fetchrow_array();
		$sth->finish;

		if ($error ne "") {
			handle($error,$script);
			die "Database Error: ${error}";
		}

		$sql = "update patrons set code = NULL, confirm = 1, password = '$password' where id = $id";
		$dbh->do($sql);
		$error = $dbh->errstr;

		if ($error ne "") {
			handle($error,$script);
			die "Database Error: ${error}";
		}

		$sql = "select name,email,username from patrons where id = ?";
		$sth = $dbh->prepare($sql);
		$sth->execute($id);
		$error = $dbh->errstr;
		($name,$email,$username) = $sth->fetchrow_array();
		$sth->finish;

		if ($error ne "") {
			handle($error,$script);
			die "Database Error: ${error}";
		}

		print qq|<h3 align="center">Password Confirmed!</h3><center><strong>You can now use your library account freely with your new password which will be mailed to you.</strong></center><br>\n|;

		open(MAIL,"|/usr/sbin/sendmail ${email}");
		print MAIL "To: ${name} <${email}>\n";
		print MAIL "From: Library Staff <${staffmail}>\n";
		print MAIL "Subject: New Library Password\n\n";
		print MAIL "Patron ID: ${id}\n";
		print MAIL "Username: ${username}\n";
		print MAIL "Password: ${pass2}\n";
		print MAIL "\nLibrary Staff\n${staffmail}\n\n";
		close(MAIL);
	} else {
		print qq|<h3 align="center">Passwords don't match!</h3>\n<h4 align="center">Hit the back button to correct it.</h4>\n|;
	}

#########################################################################################################
#
# Check the confirmation code, and if valid, print the password change form.
#
#

} else {
	if (length($confirm) != 8) {
		print qq|<h3 align="center">Invalid confirmation code.</h3>\n|;
	} else {
		$sql = "select code from patrons where id = ?";
		$sth = $dbh->prepare($sql);
		$sth->execute($id);
		$error = $dbh->errstr;
		$code = $sth->fetchrow_array();
		$sth->finish;

		if ($error ne "") {
			handle($error,$script);
			die "Database Error: ${error}";
		}

		if ($confirm eq $code) {
			print qq|<h3 align="center">Code confirmed. Please select a password.</h3>|;
			print qq|<center>\n<table border="1" width="75%" bgcolor="#000000">\n<form method="POST" action="confirm.cgi">\n<input type="hidden" name="id" value="${id}"><input type="hidden" name="confirm" value="${confirm}">\n|;
			print qq|<tr><td width="20%" bgcolor="#D3C1B6">New Password: </td><td width="80%" bgcolor="#D3C1B6"><input type="password" name="password"></td></tr>\n|;
			print qq|<tr><td width="20%" bgcolor="#D3C1B6">Password (Confirm): </td><td width="80%" bgcolor="#D3C1B6"><input type="password" name="pass2"></td></tr>\n|;
			print qq|<tr><td width="100%" align="left" bgcolor="#D3C1B6" colspan="2"><input type="submit" value="Submit Password"></td></tr>\n|;
			print qq|</table>\n</center>\n|;
		} else {
			print qq|<h3 align="center">Incorrect Confirmation Code. Please follow the link given in your confirmation email.</h3>|;
		}
	}
}

print qq|<center><a href="index.html"><strong>Return to the Main Page</strong></a><br><img border="0" src="/images/book.gif" width="116" height="68"></center>\n</body>\n</html>\n|;

$dbh->disconnect;
