###########################################################################
#            Copyright (C) 2000 John David Ratliff                        #
#                                                                         #
# Permission is hereby granted, free of charge, to any person obtaining   #
# a copy of this software and associated documentation files (the         #
# "Software"), to deal in the Software without restriction, including     #
# without limitation the rights to use, copy, modify, merge, publish,     #
# distribute, sublicense, and/or sell copies of the Software, and to      #
# permit persons to whom the Software is furnished to do so, subject to   #
# the following conditions:                                               #
#                                                                         #
# The above copyright notice and this permission notice shall be included #
# in all copies or substantial portions of the Software.                  #
#                                                                         #
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,         #
# EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF      #
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  #
# IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY    #
# CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,    #
# TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE       #
# SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.                  #
###########################################################################

#########################################################################################################
#
# Declare the local variables 
#
#

local ($patron2,$sql,$sth,$display,$uid,$title,$author,$publisher,$year);
local ($rating,$length,$system,$dyear,$dmonth,$dday,$description,$due,$sg);

#########################################################################################################
#
# sub getBooks(int patronID)
#	returns the list of checked out books to patronID in HTML table format
#

sub getBooks($) {
	($patron2) = @_;

	$sql = "select id,title,author,sg,publisher,year,description,due from catalog where patron = ? and media = 1";
	$sth = $dbh->prepare($sql);
	$sth->execute($patron2);

	$display = "";

	while (($uid,$title,$author,$sg,$publisher,$year,$description,$due) = $sth->fetchrow_array()) {
		$dyear = substr($due,0,4);
		$dmonth = substr($due,4,2);
		$dday = substr($due,6,2);

		$dmonth = getMonthName($dmonth);

		$display .= qq|<center><table width="75%" border="1" bgcolor="#000000">\n|;
		$display .= qq|<tr><td width="100%" bgcolor="#D3C1B6" colspan="2" align="center"><strong>${title}</strong></td></tr>\n|;
		$display .= qq|<tr><td width="20%" bgcolor="#D3C1B6" align="center">Book ID: </td><td width="80%" bgcolor="#D3C1B6">${uid}</td></tr>\n|;
		$display .= qq|<tr><td width="20%" bgcolor="#D3C1B6" align="center">Author: </td><td width="80%" bgcolor="#D3C1B6">${author}</td></tr>\n|;
		$display .= qq|<tr><td width="20%" bgcolor="#D3C1B6" align="center">Subject: </td><td width="80%" bgcolor="#D3C1B6">${sg}</td></tr>\n|;
		$display .= qq|<tr><td width="20%" bgcolor="#D3C1B6" align="center">Publisher: </td><td width="80%" bgcolor="#D3C1B6">${publisher}</td></tr>\n|;
		$display .= qq|<tr><td width="20%" bgcolor="#D3C1B6" align="center">Year: </td><td width="80%" bgcolor="#D3C1B6">${year}</td></tr>\n|;
		$display .= qq|<tr><td width="20%" bgcolor="#D3C1B6" align="center">Description: </td><td width="80%" bgcolor="#D3C1B6">${description}</td></tr>\n|;
		$display .= qq|<tr><td width="20%" bgcolor="#D3C1B6" align="center">Due Date: </td><td width="80%" bgcolor="#D3C1B6">${dmonth} ${dday}, ${dyear}</td></tr>\n|;
		$display .= qq|</table></center><br>\n\n|;
	}

	return $display;
}

#########################################################################################################
#
# sub getMovies(int patronID)
#	returns the list of checked out movies to patronID in HTML table format
#

sub getMovies($) {
	($patron2) = @_;

	$sql = "select id,title,sg,rating,length,description,system,due from catalog where patron = ? and media = 2";
	$sth = $dbh->prepare($sql);
	$sth->execute($patron2);

	$display = "";

	while (($uid,$title,$sg,$rating,$length,$description,$system,$due) = $sth->fetchrow_array()) {
		$dyear = substr($due,0,4);
		$dmonth = substr($due,4,2);
		$dday = substr($due,6,2);

		$dmonth = getMonthName($dmonth);

		$display .= qq|<center><table width="75%" border="1" bgcolor="#000000">\n|;
		$display .= qq|<tr><td width="100%" bgcolor="#D3C1B6" colspan="2" align="center"><strong>${title}</strong></td></tr>\n|;
		$display .= qq|<tr><td width="20%" bgcolor="#D3C1B6" align="center">Movie ID: </td><td width="80%" bgcolor="#D3C1B6">${uid}</td></tr>\n|;
		$display .= qq|<tr><td width="20%" bgcolor="#D3C1B6" align="center">Genre: </td><td width="80%" bgcolor="#D3C1B6">${sg}</td></tr>\n|;
		$display .= qq|<tr><td width="20%" bgcolor="#D3C1B6" align="center">Rating: </td><td width="80%" bgcolor="#D3C1B6">${rating}</td></tr>\n|;
		$display .= qq|<tr><td width="20%" bgcolor="#D3C1B6" align="center">Length: </td><td width="80%" bgcolor="#D3C1B6">${length}</td></tr>\n|;

		if ($system == 1) {
			$display .= qq|<tr><td width="20%" bgcolor="#D3C1B6" align="center">System: </td><td width="80%" bgcolor="#D3C1B6">VHS Videocasette</td></tr>\n|;
		} elsif ($system == 2) {
			$display .= qq|<tr><td width="20%" bgcolor="#D3C1B6" align="center">System: </td><td width="80%" bgcolor="#D3C1B6">DVD Disc</td></tr>\n|;
		}

		$display .= qq|<tr><td width="20%" bgcolor="#D3C1B6" align="center">Description: </td><td width="80%" bgcolor="#D3C1B6">${description}</td></tr>\n|;
		$display .= qq|<tr><td width="20%" bgcolor="#D3C1B6" align="center">Due Date: </td><td width="80%" bgcolor="#D3C1B6">${dmonth} ${dday}, ${dyear}</td></tr>\n|;
		$display .= qq|</table></center><br>\n\n|;
	}

	return $display;
}
1;
