###########################################################################
#            Copyright (C) 2003-2004 John David Ratliff                   #
#                                                                         #
# Permission is hereby granted, free of charge, to any person obtaining   #
# a copy of this software and associated documentation files (the         #
# "Software"), to deal in the Software without restriction, including     #
# without limitation the rights to use, copy, modify, merge, publish,     #
# distribute, sublicense, and/or sell copies of the Software, and to      #
# permit persons to whom the Software is furnished to do so, subject to   #
# the following conditions:                                               #
#                                                                         #
# The above copyright notice and this permission notice shall be included #
# in all copies or substantial portions of the Software.                  #
#                                                                         #
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,         #
# EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF      #
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  #
# IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY    #
# CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,    #
# TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE       #
# SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.                  #
###########################################################################

############################################################################################
# Perl imports
#

use DBI;
use CGI qw(:param);

# change this to point to your mysql information file, which should only be readable by
# this script. e.g. in a private apache only directory with 400 access to the file!

$mysql_info_file = "...";

############################################################################################
# database connection function
#

sub dbiConnect {
	# local variables
	local ($dbn,$temp,$user,$pass,$server,$db,$dbh);
	
	# grab the function arguments
	($dbn) = @_;

	# open the connect information file
	open(FILE,"${mysql_info_file}");
	while (<FILE>) {
		$temp = $_;
		chomp($temp);
		($user,$pass,$server) = split(/:/,$temp);
	}
	close(FILE);

	# connect to the database
	$db = "DBI:mysql:${dbn}:${server}";
	$dbh = DBI->connect($db,$user,$pass);

	# return the connection handle
	return $dbh;
}

#
# end of script
############################################################################################

1;
