###########################################################################
#            Copyright (C) 2000 John David Ratliff                        #
#                                                                         #
# Permission is hereby granted, free of charge, to any person obtaining   #
# a copy of this software and associated documentation files (the         #
# "Software"), to deal in the Software without restriction, including     #
# without limitation the rights to use, copy, modify, merge, publish,     #
# distribute, sublicense, and/or sell copies of the Software, and to      #
# permit persons to whom the Software is furnished to do so, subject to   #
# the following conditions:                                               #
#                                                                         #
# The above copyright notice and this permission notice shall be included #
# in all copies or substantial portions of the Software.                  #
#                                                                         #
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,         #
# EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF      #
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  #
# IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY    #
# CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,    #
# TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE       #
# SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.                  #
###########################################################################

#########################################################################################################
#
# global variables
#
#

# these variables should be changed to suit your server
$server = "http://myserver/path/to/library";
$fullpath = "/some/directory/that/points/to/the/htdocs/of/the/library";
$adminmail = "myadmin@myorg.net";
$staffmail = "mystaff@myorg.net";
$dbname = "your_sql_database_name";

#########################################################################################################
#
# handle(string error)
#
# Handles database errors by loggin them in a file complete with the error message, the script
# which caused the error, and the time of the error to faciliate easier log checking.
#

sub handle($$) {
	local ($error,$script) = @_;
	local (@ctime,$month,$day,$year,$hour,$minute);

	(@ctime) = localtime(time);

	$month = $ctime[4] + 1;
	$year = $ctime[5] + 1900;
	$day = $ctime[3];
	$hour = $ctime[2];

	if ($ctime[1] > 10) {
		$minute = $ctime[1];
	} else {
		$minute = "0$ctime[1]";
	}

	open(ERRORLOG,">>${fullpath}/staff/errorlog.txt");
	print ERRORLOG "Database Error on ${month}-${day}-${year} at ${hour}:${minute} in Script ${script}.\n";
	print ERRORLOG "\tError String: ${error}\n\n";
	close(ERRORLOG);

	print qq|<h3 align="center">There has been a database error, and we were unable to complete your request. The library staff has been notified of this error and it will be fixed as soon as possible. Please try your request again later. Sorry for any inconvenience, The Library Staff.</h3>\n|;
	print qq|<h4 align="center">If you would like to send the library feedback, please <a href="${server}/feedback.cgi">click here</a> for our feedback form, or <a href="mailto:${staffmail}">here to email us</a>.</h4>\n|;

	print qq|<br><center><a href="index.html"><strong>Return to the Main Page</strong></a><br><img border="0" src="/images/book.gif" width="116" height="68"></center>\n|;
}
1;
