#!/usr/bin/perl

###########################################################################
#            Copyright (C) 2000 John David Ratliff                        #
#                                                                         #
# Permission is hereby granted, free of charge, to any person obtaining   #
# a copy of this software and associated documentation files (the         #
# "Software"), to deal in the Software without restriction, including     #
# without limitation the rights to use, copy, modify, merge, publish,     #
# distribute, sublicense, and/or sell copies of the Software, and to      #
# permit persons to whom the Software is furnished to do so, subject to   #
# the following conditions:                                               #
#                                                                         #
# The above copyright notice and this permission notice shall be included #
# in all copies or substantial portions of the Software.                  #
#                                                                         #
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,         #
# EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF      #
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  #
# IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY    #
# CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,    #
# TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE       #
# SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.                  #
###########################################################################

use CGI qw(:param);
use DBI;

require "lib/dbi-connect.pl";
require "lib/error.pl";

#########################################################################################################
#
# Declare the local variables, print the content type, set the script variable, establish the database
# connection and print the header
#

local ($script,$dbh,$error,$email,$sql,$sth,$id,$username,$code);

print "Content-type: text/html\n\n";

$script = "passchange.cgi";
$dbh = dbiConnect($dbname);

print <<HTML;
<html>

<head>
	<title>Username Lookup / Password Change Form</title>

	<style fprolloverstyle>
		A:hover {color: darkgreen; font-weight: bold}
	</style>
</head>

<body background="/images/background.gif" link="#800000" vlink="#C00000" alink="#000080">
HTML

#########################################################################################################
#
# Generate a confirmation code and mail it to the patron's email account. Protect against invalid email.
#
#

$email = param("email");

$sql = "select id,username from patrons where email = ?";
$sth = $dbh->prepare($sql);
$sth->execute($email);
$error = $dbh->errstr;
($id,$username) = $sth->fetchrow_array();
$sth->finish;

if ($error ne "") {
	handle($error,$script);
	die;
}

$code = "";

########################################
# random confirmation code generation
# written by Adam Berlinsky-Schine
#
for ($i = 0; $i < 4; $i++) {
	$code .= chr (int(rand 26) + 97);
}

for ($i = 0; $i < 4; $i++) {
	$code .= int (rand 9) + 0;
}
#
#
########################################

if ($id != 0) {
	$sql = "update patrons set code = '$code' where id = $id";
	$dbh->do($sql);
	$error = $dbh->errstr;

	if ($error ne "") {
		handle($error,$script);
		die "Database Error: ${error}";
	}

	open(MAIL,"|/usr/sbin/sendmail ${email}");
	print MAIL qq|To: ${name} <${email}>\n|;
	print MAIL qq|From: Library Staff <${staffmail}>\n|;
	print MAIL qq|Subject: Password Change Form\n\n|;
	print MAIL qq|Patron ID: ${id}\n|;
	print MAIL qq|E-Mail: ${email}\n|;
	print MAIL qq|\nYou Can Change Your Password at: ${server}/confirm.cgi?confirm=${code}&id=${id}\n|;
	print MAIL qq|\nLibrary Staff\n${staffmail}\n\n|;
	close(MAIL);

	print qq|<h3 align="center">Your password change form has been mailed to you.</h3><br>\n|;
}


print qq|<center><a href="index.html"><strong>Return to the Main Page</strong></a><br><img border="0" src="/images/book.gif" width="116" height="68"></center>\n</body>\n</html>\n|;

$dbh->disconnect;
