#!/usr/bin/perl

###########################################################################
#            Copyright (C) 2000 John David Ratliff                        #
#                                                                         #
# Permission is hereby granted, free of charge, to any person obtaining   #
# a copy of this software and associated documentation files (the         #
# "Software"), to deal in the Software without restriction, including     #
# without limitation the rights to use, copy, modify, merge, publish,     #
# distribute, sublicense, and/or sell copies of the Software, and to      #
# permit persons to whom the Software is furnished to do so, subject to   #
# the following conditions:                                               #
#                                                                         #
# The above copyright notice and this permission notice shall be included #
# in all copies or substantial portions of the Software.                  #
#                                                                         #
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,         #
# EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF      #
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  #
# IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY    #
# CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,    #
# TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE       #
# SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.                  #
###########################################################################

use CGI qw(:param);
use DBI;

require "../lib/dbi-connect.pl";
require "../lib/error.pl";

#########################################################################################################
#
# Declare the local variables, print the content type, set the script variable, establish the database
# connection and print the header.
#

local ($script,$dbh,$error,$id,$sql,$sth,$patron,$reserve,$name,$email,$title,$description,$sg,$idgood);

print "Content-type: text/html\n\n";

$script = "staff/checkin.cgi";
$dbh = dbiConnect($dbname);

print <<HTML;
<html>

<head>
	<title>Check Items Into Library</title>

	<style fprolloverstyle>
		A:hover {color: darkgreen; font-weight: bold}
	</style>
</head>

<body background="/images/background.gif" link="#800000" vlink="#C00000" alink="#000080">
HTML

#########################################################################################################
#
# Check an item back into the library based on its ID number. Disallow invalid ID's.
#
#

if (param()) {
	$id = param("id");
	$id = int($id);

	$sql = "select patron,reserve from catalog where id = ?";
	$sth = $dbh->prepare($sql);
	$sth->execute($id);
	$idgood = $sth->rows;
	$error = $dbh->errstr;
	($patron,$reserve) = $sth->fetchrow_array();
	$sth->finish;

	if ($error ne "") {
		handle($error,$script);
		die "Database Error: ${error}";
	}

	if ($idgood != 1) {
		print qq|<h3 align="center">Invalid ID Number</h3>\n|;
	} else {
		$sql = "update catalog set patron = 0, due = 0, lost = 0 where id = $id";
		$dbh->do($sql);
		$error = $dbh->errstr;

		if ($error ne "") {
			handle($error,$script);
			die "Database Error: ${error}";
		}

		if ($reserve != 0) {
			$sql = "select name,email from patrons where id = ?";
			$sth = $dbh->prepare($sql);
			$sth->execute($reserve);
			$error = $dbh->errstr;
			($name,$email) = $sth->fetchrow_array();
			$sth->finish;

			if ($error ne "") {
				handle($error,$script);
				die "Database Error: ${error}";
			}

			$sql = "update catalog set rtime = NULL where id = $id";
			$dbh->do($sql);
			$error = $dbh->errstr;

			if ($error ne "") {
				handle($error,$script);
				die "Database Error: ${error}";
			}

			$sql = "select title,sg,description from catalog where id = ?";
			$sth = $dbh->prepare($sql);
			$sth->execute($id);
			$error = $dbh->errstr;
			($title,$sg,$description) = $sth->fetchrow_array();
			$sth->finish;

			if ($error ne "") {
				handle($error,$script);
				die "Database Error: ${error}";
			}

			open(MAIL,"|/usr/sbin/sendmail ${email}");
			print MAIL "To: ${name} <${email}>\n";
			print MAIL "From: Library Staff <${staffmail}>\n";
			print MAIL "Subject: Your Reservation is In\n\n";
			print MAIL "Catalog ID: ${id}\n";
			print MAIL "Title: ${title}\n";
			print MAIL "Subject/Genre: ${sg}\n";
			print MAIL "Description: ${description}\n";
			print MAIL "\nYou have 7 days to pick it up before it is returned to the shelves.\n";
			print MAIL "\nLibrary Staff\n${staffmail}\n\n";
			close(MAIL);

			print qq|<h3 align="center">This item is currently on reserve for ${name} and has been notified to pick it up via email. Please hold it for this patron.|;
		} else {
			print qq|<h3 align="center">Item Checked In. Please reshelf A.S.A.P.</h3>\n|;
		}
	}
}

#########################################################################################################
#
# Display the checkin form.
#
#

print <<HTML;
<h1 align="center">Library Check-In System</h1>

<center>
	<form method="POST" action="checkin.cgi">
		<table width="75%" border="1" bgcolor="#000000">
			<tr>
				<td width="100%" bgcolor="#D3C1B6" align="center" colspan="2"><strong>Check a Book Back Into the Library</strong></td>
			</tr>

			<tr>
				<td width="20%" bgcolor="#D3C1B6">Catalog ID: </td>
				<td width="80%" bgcolor="#D3C1B6"><input type="text" name="id" size="5"> <font size="-1"><a href="../search.html" target="_blank">Click Here to Find the ID Number</a></font></td>
			</tr>

			<tr>
				<td width="100%" colspan="2" align="left" bgcolor="#D3C1B6"><input type="submit" value="Check Book In"></td>
			</tr>
		</table>
	</form>
</center>
HTML

print <<HTML;
<center>
	<a href="index.html"><strong>Return to the Staff Page</strong></a>
	<br><img border="0" src="/images/book.gif" width="116" height="68">
	
	<p><h5>
		Web design by Jennifer Joy Hawkins
		<br>Copyright (C) 2000 Jennifer Joy Hawkins
		<br>All Rights Reserved
	</h5></p>
</center>
</body>

</html>
HTML

$dbh->disconnect;
