#!/usr/bin/perl

###########################################################################
#            Copyright (C) 2000 John David Ratliff                        #
#                                                                         #
# Permission is hereby granted, free of charge, to any person obtaining   #
# a copy of this software and associated documentation files (the         #
# "Software"), to deal in the Software without restriction, including     #
# without limitation the rights to use, copy, modify, merge, publish,     #
# distribute, sublicense, and/or sell copies of the Software, and to      #
# permit persons to whom the Software is furnished to do so, subject to   #
# the following conditions:                                               #
#                                                                         #
# The above copyright notice and this permission notice shall be included #
# in all copies or substantial portions of the Software.                  #
#                                                                         #
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,         #
# EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF      #
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  #
# IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY    #
# CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,    #
# TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE       #
# SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.                  #
###########################################################################

use CGI qw(:param);
use DBI;

require "../lib/dbi-connect.pl";
require "../lib/error.pl";

#########################################################################################################
#
# Declare the local variables, print the content type, setup the script variable, establish the database
# connection, and print the header
#

local ($script,$dbh,$error,$confirm,$name,$email,$street,$city,$zip);
local ($month,$day,$year,$username,$code,$sql,$sth,$id,$phone,$gender);

print "Content-type: text/html\n\n";

$script = "staff/newpatron.cgi";
$dbh = dbiConnect($dbname);

print <<HTML;
<html>

<head>
	<title>New Account Setup</title>

	<style fprolloverstyle>
		A:hover {color: darkgreen; font-weight: bold}
	</style>
</head>

<body background="/images/background.gif" link="#800000" vlink="#C00000" alink="#000080">
HTML

#########################################################################################################
#
# Either reprint the submitted info for correctness, or add the account to the database based on the
# confirm parameter set to 1 or not at all.
#

if (param()) {
	$confirm = param("confirm");
	$name = param("name");
	$email = param("email");
	$street = param("street");
	$city = param("city");
	$zip = param("zip");
	$phone = param("phone");
	$gender = param("gender");
	$month = param("month");
	$day = param("day");
	$year = param("year");
	$username = param("username");

	if ($confirm == 1) {
		$code = "";

##########################################################################
# random confirmation code generator
# by Adam Berlinsky-Schine
#
		for ($i = 0; $i < 4; $i++) {
			$code .= chr (int(rand 26) + 97);
		}

		for ($i = 0; $i < 4; $i++) {
			$code .= int (rand 9) + 0;
		}
#
##########################################################################

		$sql = "insert into patrons (name,email,street,city,zip,phone,gender,month,day,year,username,code,password,confirm) values (?,?,?,?,?,?,?,?,?,?,?,?,?,1)";
		$sth = $dbh->prepare($sql);
		$sth->execute($name,$email,$street,$city,$zip,$phone,$gender,$month,$day,$year,$username,$code,$code);
		$error = $dbh->errstr;
		$id = $sth->{'mysql_insertid'};
		$sth->finish;

		if ($error ne "") {
			if (($error =~ /Duplicate entry '.*' for key 3/) != 0) {
				print qq|<h1 align="center">Username Already Taken</h1>\n|;
				print qq|<center>\n<form method="POST" action="newpatron.cgi">\n|;
				print qq|<input type="hidden" name="confirm" value="1">|;
				print qq|<input type="hidden" name="name" value="${name}">|;
				print qq|<input type="hidden" name="email" value="${email}">|;
				print qq|<input type="hidden" name="street" value="${street}">|;
				print qq|<input type="hidden" name="city" value="${city}">|;
				print qq|<input type="hidden" name="zip" value="${zip}">|;
				print qq|<input type="hidden" name="phone" value="${phone}">|;
				print qq|<input type="hidden" name="gender" value="${gender}">|;
				print qq|<input type="hidden" name="month" value="${month}">|;
				print qq|<input type="hidden" name="day" value="${day}">|;
				print qq|<input type="hidden" name="year" value="${year}">|;
				print qq|<table border="1" width="75%" bgcolor="#000000">\n|;
				print qq|<tr><td width="100%" align="center" colspan="2" bgcolor="#D3C1B6">Username already taken. Please choose again!</td></tr>\n|;
				print qq|<tr><td width="20%" bgcolor="#D3C1B6">New Username: </td><td width="80%" bgcolor="#D3C1B6"><input type="text" name="username"></td></tr>\n|;
				print qq|<tr><td width="100%" align="left" colspan="2" bgcolor="#D3C1B6"><input type="submit" value="Try Again"></td></tr>\n|;
				print qq|</table>\n</form>\n</center>\n|;
			} elsif (($error =~ /Duplicate entry '.*' for key 2/) != 0) {
				$sql = "select id from patrons where email = ?";
				$sth = $dbh->prepare($sql);
				$sth->execute($email);
				$error = $dbh->errstr;
				$id = $sth->fetchrow_array();
				$sth->finish;

				if ($error ne "") {
					handle($error,$script);
					die "Database Error: ${error}";
				}

				print qq|<h1 align="center">Account Already Exists</h1>|;
				print qq|<center><strong>Your email account already has an account. Do you want us to send you a password change form?</strong>\n|;
				print qq|<form method="POST" action="passchange.cgi"><input type="hidden" name="email" value="${email}"><input type="submit" value="Yes, E-Mail Me"></form>\n|;
				print qq|<br><br>\n<a href="index.html"><strong>Return to the Main Page</strong></a><br><img border="0" src="/images/book.gif" width="116" height="68"></center>\n|;
			} else {
				handle($error,$script);
				die "Database Error: ${error}";
			}
		} else {

			print qq|<h1 align="center">Account Created Successfully.</h1>\n|;
			print qq|<center>\n<table width="75%" border="1" bgcolor="#000000">\n|;
			print qq|<tr><td width="100%" align="center" colspan="2" bgcolor="#D3C1B6"><strong>New Account Information</strong></td></tr>\n|;
			print qq|<tr><td width="20%" bgcolor="#D3C1B6">Patron ID: </td><td width="80%" bgcolor="#D3C1B6">${id}</td></tr>\n|;
			print qq|<tr><td width="20%" bgcolor="#D3C1B6">Username: </td><td width="80%" bgcolor="#D3C1B6">${username}</td></tr>\n|;
			print qq|<tr><td width="20%" bgcolor="#D3C1B6">E-Mail: </td><td width="80%" bgcolor="#D3C1B6">${email}</td></tr>\n|;
			print qq|<tr><td width="100%" align="center" colspan="2" bgcolor="#D3C1B6">Keep this information in a safe place. You can retrieve lost passwords ONLY from this email address.<br>A confirmation code has been mailed to you. You will need to use it to set your password.</td></tr>|;
			print qq|</table>\n</center>\n|;

			open(MAIL,"|/usr/sbin/sendmail ${email}");
			print MAIL qq|To: ${name} <${email}>\n|;
			print MAIL qq|From: Library Staff <${staffmail}>\n|;
			print MAIL qq|Subject: New Library Account\n\n|;
			print MAIL qq|Account Created Successfully.\n|;
			print MAIL qq|New Account Information\n|;
			print MAIL qq|Patron ID: ${id}\n|;
			print MAIL qq|Username: ${username}\n|;
			print MAIL qq|E-Mail: ${email}\n|;
			print MAIL qq|\nSet the Password for Your Account at: ${server}/confirm.cgi?confirm=${code}&id=${id}\n|;
			print MAIL qq|Library Staff\n${staffmail}\n\n|;
			close(MAIL);
		}
	} else {
		(@ctime) = localtime(time);
		$ctime[5]+=1900;

		if ($year < 100) {
			$year += 1900;
		} elsif ($year < 200) {
			$year += 1800;
		}

		if ($year > $ctime[5]) {
			print qq|<h3 align="center">Error: Invalid Year.</h3>|;
			print qq|<h4 align="center">Hit the back button to correct it.</h4>|;
		} elsif ($name eq "" || $email eq "" || $street eq "" || $city eq "" || $zip eq "" || $phone eq "" || $gender eq "" || $month eq "" || $day eq "" || $year eq "" || $username eq "") {
			print qq|<h3 align="center">Error: You left at least one of the fields blank.</h3>|;
			print qq|<h4 align="center">Hit the back button to correct it.</h4>|;
		} elsif (($phone =~ /^\d\d\d-\d\d\d-\d\d\d\d$/) == 0) {
			print qq|<h3 align="center">Error: Please enter your phone number in the form ###-###-#### [Example: 800-555-1212]</h3>|;
			print qq|<h4 align="center">Hit the back button to correct it.</h4>|;
		} elsif (($zip =~ /^\d\d\d\d\d$/) == 0) {
			print qq|<h3 align="center">Error: Please enter your zipcode in the format ##### (Example: 90210).</h3>|;
			print qq|<h4 align="center">Hit the back button to correct it.</h4>|;
		} elsif (($name =~ /\d/) != 0) {
			print qq|<h3 align="center">Error: Names may not contain non-alphabetic characters. [Example: John Doe]</h3>|;
			print qq|<h4 align="center">Hit the back button to correct it.</h4>|;
		} elsif (($email =~ /^\w{1,}@.+\.[A-z]{2,4}$/) == 0) {
			print qq|<h3 align="center">Error: E-Mail addresses must be in the form you\@your.domain [Example: someone\@microsoft.com].</h3>|;
			print qq|<h4 align="center">Hit the back button to correct it.</h4>|;
		} elsif (length($name) > 50 || length($email) > 30 || length($street) > 30 || length($city) > 30 || length($username) > 20) {
			print qq|<h3 align="center">Error: One of the fields is too long:</h3>\n|;
			print qq|<center><table width="75%" bgcolor="#000000" border="1">\n|;
			print qq|<tr><td width="100%" bgcolor="#D3C1B6" align="center">\n|;
			print qq|Names are limited to <strong>50</strong> characters.<br>\nEmail addreses, streets, and cities are limited to <strong>30</strong> characters.<br>Usernames are limited to <strong>20</strong> characters.\n|;
			print qq|</table></center><br>\n|;
			print qq|<h4 align="center">Hit the back button to correct it.</h4>\n|;
		} else {
			print qq|<h1 align="center">New User Confirmation Form</h1>|;
			print qq|<center>\n<table width="75%" border="1" bgcolor="#000000"><form method="POST" action="newpatron.cgi">\n|;
			print qq|<input type="hidden" name="confirm" value="1"><input type="hidden" name="name" value="${name}"><input type="hidden" name="email" value="${email}"><input type="hidden" name="street" value="${street}"><input type="hidden" name="city" value="${city}"><input type="hidden" name="zip" value="${zip}"><input type="hidden" name="phone" value="${phone}"><input type="hidden" name="gender" value="${gender}"><input type="hidden" name="month" value="${month}"><input type="hidden" name="day" value="${day}"><input type="hidden" name="year" value="${year}"><input type="hidden" name="username" value="${username}">\n|;
			print qq|<tr>\n<td width="100%" align="center" colspan="2" bgcolor="#D3C1B6"><strong>New Account Information</strong></td></tr>\n|;
			print qq|<tr>\n<td width="20%" bgcolor="#D3C1B6">Name: </td>\n<td width="80%" bgcolor="#D3C1B6">${name}</td>\n</tr>\n|;
			print qq|<tr>\n<td width="20%" bgcolor="#D3C1B6">E-Mail: </td>\n<td width="80%" bgcolor="#D3C1B6">${email}</td>\n</tr>\n|;
			print qq|<tr>\n<td width="20%" bgcolor="#D3C1B6">Street Address: </td>\n<td width="80%" bgcolor="#D3C1B6">${street}</td>\n</tr>\n|;
			print qq|<tr>\n<td width="20%" bgcolor="#D3C1B6">City: </td>\n<td width="80%" bgcolor="#D3C1B6">${city}</td>\n</tr>\n|;
			print qq|<tr>\n<td width="20%" bgcolor="#D3C1B6">Zipcode: </td>\n<td width="80%" bgcolor="#D3C1B6">${zip}</td>\n</tr>\n|;
			print qq|<tr>\n<td width="20%" bgcolor="#D3C1B6">Telephone: </td>\n<td width="80%" bgcolor="#D3C1B6">${phone}</td>\n</tr>\n|;
			print qq|<tr>\n<td width="20%" bgcolor="#D3C1B6">Gender: </td>\n<td width="80%" bgcolor="#D3C1B6">${gender}</td>\n</tr>\n|;
			print qq|<tr>\n<td width="20%" bgcolor="#D3C1B6">Date of Birth: </td>\n<td width="80%" bgcolor="#D3C1B6">${month}-${day}-${year}</td>\n</tr>\n|;
			print qq|<tr>\n<td width="20%" bgcolor="#D3C1B6">Username: </td>\n<td width="80%" bgcolor="#D3C1B6">${username}</td>\n</tr>\n|;
			print qq|<tr>\n<td width="100%" align="left" colspan="2" bgcolor="#D3C1B6"><input type="submit" value="Create Account"></td></tr>\n|;
			print qq|</form></table></center>\n|;
		}
	}
} else {

#########################################################################################################
#
# If we aren't checking or confirming account information, then we need to print the new account form.
#
#

	print <<HTML;
<h1 align="center">New Patron Signup Form</h1>

<blockquote>
	<h3>
		Please fill out this form completely and press the submit button once. After your
		information is reviewed, you will be added to the system and allowed to check out
		items from the library.
	</h3>

	<form method="POST" action="newpatron.cgi">
		<table width="75%" border="1" bgcolor="#000000">
			<tr>
				<td width="20%" bgcolor="#D3C1B6">Full Name: </td>
				<td width="80%" bgcolor="#D3C1B6"><input type="text" name="name" size="30"> <font size="-1">(ex: Jane Doe)</font></td>
			</tr>

			<tr>
				<td bgcolor="#D3C1B6">E-Mail: </td>
				<td bgcolor="#D3C1B6"><input type="text" name="email" size="30"> <font size="-1">(ex: a348\@cs.indiana.edu)</font></td>
			</tr>

			<tr>
				<td bgcolor="#D3C1B6">Street Address: </td>
				<td bgcolor="#D3C1B6"><input type="text" name="street" size="30"> <font size="-1">(ex: 100 North Indiana Avenue)</font></td>
			</tr>

			<tr>
				<td bgcolor="#D3C1B6">City: </td>
				<td bgcolor="#D3C1B6"><input type="text" name="city" value="Bloomington" size="30"> <font size="-1">(ex: Bloomington)</font></td>
			</tr>

			<tr>
				<td bgcolor="#D3C1B6">Zip Code: </td>
				<td bgcolor="#D3C1B6"><input type="text" name="zip" size="5"> <font size="-1">Enter in the format ##### (ex: 47401).</font></td>
			</tr>

			<tr>
				<td bgcolor="#D3C1B6">Telephone Number: </td>
				<td bgcolor="#D3C1B6"><input type="text" name="phone" size="12"> <font size="-1">Enter in the format ###-###-#### (ex: 812-555-1212).</font></td>
			</tr>

			<tr>
				<td bgcolor="#D3C1B6">Gender: </td>
				<td bgcolor="#D3C1B6">
					<select name="gender" height="1">
						<option selected value="Male">Male</option>
						<option value="Female">Female</option>
					</select>
					</td>
			</tr>

			<tr>
				<td bgcolor="#D3C1B6">Date of Birth: </td>
				<td bgcolor="#D3C1B6">
					<select name="month" height="1">
						<option selected value="1">January</option>
						<option value="2">February</option>
						<option value="3">March</option>
						<option value="4">April</option>
						<option value="5">May</option>
						<option value="6">June</option>
						<option value="7">July</option>
						<option value="8">August</option>
						<option value="9">September</option>
						<option value="10">October</option>
						<option value="11">November</option>
						<option value="12">December</option>
					</select>

					<select name="day" height="1">
						<option selected value="1">1</option>
						<option value="2">2</option>
						<option value="3">3</option>
						<option value="4">4</option>
						<option value="5">5</option>
						<option value="6">6</option>
						<option value="7">7</option>
						<option value="8">8</option>
						<option value="9">9</option>
						<option value="10">10</option>
						<option value="11">11</option>
						<option value="12">12</option>
						<option value="13">13</option>
						<option value="14">14</option>
						<option value="15">15</option>
						<option value="16">16</option>
						<option value="17">17</option>
						<option value="18">18</option>
						<option value="19">19</option>
						<option value="20">20</option>
						<option value="21">21</option>
						<option value="22">22</option>
						<option value="23">23</option>
						<option value="24">24</option>
						<option value="25">25</option>
						<option value="26">26</option>
						<option value="27">27</option>
						<option value="28">28</option>
						<option value="29">29</option>
						<option value="30">30</option>
						<option value="31">31</option>
					</select>

					<input type="text" name="year" size="4" value="19">
					</td>
			</tr>

			<tr>
				<td bgcolor="#D3C1B6">Username: </td>
				<td bgcolor="#D3C1B6"><input type="text" name="username" size="20"> <font size="-1">No more than 20 characters (ex: billg)</font></td>
			</tr>

			<tr>
				<td bgcolor="#D3C1B6" colspan="2"><input type="submit" value="Apply Now"></td>
			</tr>
		</table>		
	</form>
</blockquote>
HTML
}

print <<HTML;
<center>
	<a href="index.html"><strong>Return to the Staff Page</strong></a>
	<br><img border="0" src="/images/book.gif" width="116" height="68">
	
	<p><h5>
		Web design by Jennifer Joy Hawkins
		<br>Copyright (C) 2000 Jennifer Joy Hawkins
		<br>All Rights Reserved
	</h5></p>
</center>
</body>

</html>
HTML

$dbh->disconnect;
