#!/usr/bin/perl

###########################################################################
#            Copyright (C) 2000 John David Ratliff                        #
#                                                                         #
# Permission is hereby granted, free of charge, to any person obtaining   #
# a copy of this software and associated documentation files (the         #
# "Software"), to deal in the Software without restriction, including     #
# without limitation the rights to use, copy, modify, merge, publish,     #
# distribute, sublicense, and/or sell copies of the Software, and to      #
# permit persons to whom the Software is furnished to do so, subject to   #
# the following conditions:                                               #
#                                                                         #
# The above copyright notice and this permission notice shall be included #
# in all copies or substantial portions of the Software.                  #
#                                                                         #
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,         #
# EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF      #
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  #
# IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY    #
# CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,    #
# TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE       #
# SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.                  #
###########################################################################

use CGI qw(:param);
use DBI;

require "../lib/dbi-connect.pl";
require "../lib/error.pl";

#########################################################################################################
#
# Define the local variables, print the content type, define the script variable, establish the database
# connection, and print the header
#

local ($script,$dbh,$error,$id,$action,$sth,$media,$title,$author,$sg,$description,$results);

print "Content-type: text/html\n\n";

$script = "staff/suggestions.cgi";
$dbh = dbiConnect($dbname);

print <<HTML;
<html>

<head>
	<title>Check Items Into Library</title>

	<style fprolloverstyle>
		A:hover {color: darkgreen; font-weight: bold}
	</style>
</head>

<body background="/images/background.gif" link="#800000" vlink="#C00000" alink="#000080">
HTML

#########################################################################################################
#
# Either reccommend the suggestion to the administrator or delete it from the database, depending upon
# the supplied action parameter. action == 1 (reccommend) ; action == 2 (delete)
#

if (param()) {
	$id = param("id");
	$action = param("action");

	if ($action == 1) {
		$sql = "select media,title,author,sg,description from suggestions where id = ?";
		$sth = $dbh->prepare($sql);
		$sth->execute($id);
		$error = $dbh->errstr;
		($media,$title,$author,$sg,$description) = $sth->fetchrow_array();
		$sth->finish;

		if ($error ne "") {
			handle($error,$script);
			die "Database Error: ${error}";
		}

		open(MAIL,"|/usr/sbin/sendmail ${adminmail}");
		print MAIL "To: Library Administrator <${adminmail}>\n";
		print MAIL "From: Library Staff <${staffmail}>\n";
		print MAIL "Subject: Suggestion for an Addition to the Library Catalog\n\n";

		if ($media == 1) {
			print MAIL "New Book Suggestion.\n";
		} elsif ($media == 2) {
			print MAIL "New Movie Suggestion.\n";
		}

		print MAIL "Title: ${title}\n";

		if ($media == 1) {
			print MAIL "Author: ${author}\n";
			print MAIL "Subject: ${sg}\n";
		} elsif ($media == 2) {
			print MAIL "Genre: ${sg}\n";
		}

		print MAIL "Description: ${description}\n\n";
		print MAIL "You can delete this suggestion from the list at this URL: ${server}/staff/suggestions.cgi?id=${id}&action=2\n";
		print MAIL "\nLibrary Staff\n${staffmail}\n\n";
		close(MAIL);

		print qq|<h3 align="center">This suggestion was referred to the administrator.</h3>\n|;
	} elsif ($action == 2) {
		$sql = "delete from suggestions where id = $id";
		$dbh->do($sql);

		if ($error ne "") {
			handle($error,$script);
			die "Database Error: ${error}";
		}

		print qq|<h3 align="center">Suggestion Has Been Deleted.</h3>\n|;
	}
}

#########################################################################################################
#
# Display the list of patron suggestions obtained from the database
#
#
print qq|<h1 align="center">Patron Catalog Addition Suggestions</h1>\n|;

$display = "";

$sql = "select id,media,title,author,sg,description from suggestions order by media,author,title,sg";
$sth = $dbh->prepare($sql);
$sth->execute();
$results = $sth->rows;
$error = $dbh->errstr;

while (($id,$media,$title,$author,$sg,$description) = $sth->fetchrow_array()) {
	$display .= qq|<center><table width="75%" border="1" bgcolor="#000000"><form method="POST" action="suggestions.cgi"><input type="hidden" name="id" value="${id}">\n|;

	if ($media == 1) {
		$display .= qq|<tr><td width="100%" bgcolor="#D3C1B6" colspan="2" align="center"><strong>New Book Suggestion</strong></td></tr>|;
	} elsif ($media == 2) {
		$display .= qq|<tr><td width="100%" bgcolor="#D3C1B6" colspan="2" align="center"><strong>New Movie Suggestion</strong></td></tr>|;
	}

	$display .= qq|<tr><td width="20%" bgcolor="#D3C1B6" align="center">Title: </td><td width="80%" bgcolor="#D3C1B6">${title}</td></tr>\n|;

	if ($media == 1) {
		$display .= qq|<tr><td width="20%" bgcolor="#D3C1B6" align="center">Author: </td><td width="80%" bgcolor="#D3C1B6">${author}</td></tr>\n|;
		$display .= qq|<tr><td width="20%" bgcolor="#D3C1B6" align="center">Subject: </td><td width="80%" bgcolor="#D3C1B6">${sg}</td></tr>\n|;
	} elsif ($media == 2) {
		$display .= qq|<tr><td width="20%" bgcolor="#D3C1B6" align="center">Genre: </td><td width="80%" bgcolor="#D3C1B6">${sg}</td></tr>\n|;
	}

	$display .= qq|<tr><td width="20%" bgcolor="#D3C1B6" align="center">Description: </td><td width="80%" bgcolor="#D3C1B6">${description}</td></tr>\n|;
	$display .= qq|<tr><td width="20%" bgcolor="#D3C1B6" align="center">Action: </td><td width="80%" bgcolor="#D3C1B6"><select name="action" height="1"><option value="1">Reccommend Item to the Administrator</option><option value="2">Delete This Suggestion</option></select></td></tr>\n|;
	$display .= qq|<tr><td width="100%" bgcolor="#D3C1B6" align="left" colspan="2"><input type="submit" value="Submit"</td></tr>\n|;
	$display .= qq|</form></table></center><br>\n\n|;
}
$sth->finish;

if ($error ne "") {
	handle($error,$script);
	die "Database Error: ${error}";
}

if ($results == 0) {
	print qq|<h3 align="center">No Patron Suggestions at This Time</h3>\n|;
} elsif ($results == 1) {
	print qq|<h3 align="center">1 Suggestion</h3>\n${display}\n|;
} else {
	print qq|<h3 align="center">${results} Patron Suggestions</h3>\n${display}\n|;
}

print <<HTML;
<center>
	<a href="index.html"><strong>Return to the Staff Page</strong></a>
	<br><img border="0" src="/images/book.gif" width="116" height="68">
	
	<p><h5>
		Web design by Jennifer Joy Hawkins
		<br>Copyright (C) 2000 Jennifer Joy Hawkins
		<br>All Rights Reserved
	</h5></p>
</center>
</body>

</html>
HTML

$dbh->disconnect;
